<TeXmacs|1.0.7.19>

<style|generic>

<\body>
  <\session|python|default>
    <\output>
      Python plugin for TeXmacs.

      Please see the documentation in Help -\<gtr\> plugins -\<gtr\> Python
    </output>

    <\input|Python] >
      from sympy import *
    </input>

    <\unfolded-io|Python] >
      var('a:z')
    <|unfolded-io>
      \ (a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u, v, w,
      x, y, z)
    </unfolded-io>

    <\input|Python] >
      from sympy.combinatorics.permutations import *
    </input>

    <\input|Python] >
      import itertools
    </input>

    <\input|Python] >
      from sympy.combinatorics.generators import symmetric, alternating
    </input>

    <\input|Python] >
      from sympy.combinatorics import PermutationGroup
    </input>

    <\input|Python] >
      from sympy.combinatorics.polyhedron import tetrahedron
    </input>

    <\input|Python] >
      from sympy.combinatorics.named_groups import CyclicGroup, DihedralGroup
    </input>

    <\input|Python] >
      from sympy.ntheory import *
    </input>

    <\input|Python] >
      <\code>
        <code*|from collections import OrderedDict>
      </code>
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      g = range(100)
    </input>

    <\unfolded-io|Python] >
      g.index(8*4)
    <|unfolded-io>
      \ 32
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      def print_cayley_table(G):\ 

      \ \ \ \ for a in G:\ 

      \ \ \ \ \ \ \ \ for b in G:\ 

      \ \ \ \ \ \ \ \ \ \ \ \ c = a*b\ 

      \ \ \ \ \ \ \ \ \ \ \ \ print G.index(c),\ 

      \ \ \ \ \ \ \ \ print
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      G = tetrahedron.pgroup
    </input>

    <\input|Python] >
      H = PermutationGroup(list(G.generate()))
    </input>

    <\input|Python] >
      g = list(H)
    </input>

    <\unfolded-io|Python] >
      g
    <|unfolded-io>
      \ [Permutation(0, 3, 1), Permutation(3), Permutation(1, 2, 3),
      Permutation(0, 2)(1, 3), Permutation(3)(0, 2, 1), Permutation(0, 2, 3),
      Permutation(0, 3)(1, 2), Permutation(1, 3, 2), Permutation(0, 1)(2, 3),
      Permutation(0, 3, 2), Permutation(3)(0, 1, 2), Permutation(0, 1, 3)]
    </unfolded-io>

    <\input|Python] >
      n = len(g)
    </input>

    <\unfolded-io|Python] >
      n
    <|unfolded-io>
      \ 12
    </unfolded-io>

    <\input|Python] >
      m = []
    </input>

    <\input|Python] >
      for i in g:\ 

      \ \ \ \ m.append([g.index(i*H) for H in g])
    </input>

    <\unfolded-io|Python] >
      m
    <|unfolded-io>
      \ [[11, 0, 8, 10, 6, 2, 7, 4, 5, 3, 9, 1], [0, 1, 2, 3, 4, 5, 6, 7, 8,
      9, 10, 11], [6, 2, 7, 4, 5, 3, 9, 1, 11, 0, 8, 10], [5, 3, 9, 1, 11, 0,
      8, 10, 6, 2, 7, 4], [3, 4, 0, 2, 10, 6, 11, 8, 9, 7, 1, 5], [4, 5, 6,
      7, 8, 9, 10, 11, 0, 1, 2, 3], [10, 6, 11, 8, 9, 7, 1, 5, 3, 4, 0, 2],
      [9, 7, 1, 5, 3, 4, 0, 2, 10, 6, 11, 8], [7, 8, 4, 6, 2, 10, 3, 0, 1,
      11, 5, 9], [8, 9, 10, 11, 0, 1, 2, 3, 4, 5, 6, 7], [2, 10, 3, 0, 1, 11,
      5, 9, 7, 8, 4, 6], [1, 11, 5, 9, 7, 8, 4, 6, 2, 10, 3, 0]]
    </unfolded-io>

    <\unfolded-io|Python] >
      TableForm(m, headings=[range(n), range(n)], wipe_zeros=False)
    <|unfolded-io>
      \ \ \ \ \| 0 \ 1 \ 2 \ 3 \ 4 \ 5 \ 6 \ 7 \ 8 \ 9 \ 10 11

      ----------------------------------------

      \ 0 \| 11 0 \ 8 \ 10 6 \ 2 \ 7 \ 4 \ 5 \ 3 \ 9 \ 1\ 

      \ 1 \| 0 \ 1 \ 2 \ 3 \ 4 \ 5 \ 6 \ 7 \ 8 \ 9 \ 10 11

      \ 2 \| 6 \ 2 \ 7 \ 4 \ 5 \ 3 \ 9 \ 1 \ 11 0 \ 8 \ 10

      \ 3 \| 5 \ 3 \ 9 \ 1 \ 11 0 \ 8 \ 10 6 \ 2 \ 7 \ 4\ 

      \ 4 \| 3 \ 4 \ 0 \ 2 \ 10 6 \ 11 8 \ 9 \ 7 \ 1 \ 5\ 

      \ 5 \| 4 \ 5 \ 6 \ 7 \ 8 \ 9 \ 10 11 0 \ 1 \ 2 \ 3\ 

      \ 6 \| 10 6 \ 11 8 \ 9 \ 7 \ 1 \ 5 \ 3 \ 4 \ 0 \ 2\ 

      \ 7 \| 9 \ 7 \ 1 \ 5 \ 3 \ 4 \ 0 \ 2 \ 10 6 \ 11 8\ 

      \ 8 \| 7 \ 8 \ 4 \ 6 \ 2 \ 10 3 \ 0 \ 1 \ 11 5 \ 9\ 

      \ 9 \| 8 \ 9 \ 10 11 0 \ 1 \ 2 \ 3 \ 4 \ 5 \ 6 \ 7\ 

      10 \| 2 \ 10 3 \ 0 \ 1 \ 11 5 \ 9 \ 7 \ 8 \ 4 \ 6\ 

      11 \| 1 \ 11 5 \ 9 \ 7 \ 8 \ 4 \ 6 \ 2 \ 10 3 \ 0
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      A4 = alternating(4)
    </input>

    <\input|Python] >
      g = list(A4)
    </input>

    <\unfolded-io|Python] >
      g
    <|unfolded-io>
      \ [Permutation(3), Permutation(1, 2, 3), Permutation(1, 3, 2),
      Permutation(0, 1)(2, 3), Permutation(3)(0, 1, 2), Permutation(0, 1, 3),
      Permutation(3)(0, 2, 1), Permutation(0, 2, 3), Permutation(0, 2)(1, 3),
      Permutation(0, 3, 1), Permutation(0, 3, 2), Permutation(0, 3)(1, 2)]
    </unfolded-io>

    <\input|Python] >
      n = len(g)
    </input>

    <\unfolded-io|Python] >
      n
    <|unfolded-io>
      \ 12
    </unfolded-io>

    <\input|Python] >
      <\code>
        dict1 = OrderedDict()
      </code>
    </input>

    <\input|Python] >
      dict1['e'] = Permutation(3)\ 

      dict1['s1'] = Permutation(0, 1)(2, 3)

      dict1['s2'] = Permutation(0, 2)(1, 3)

      dict1['s3'] = Permutation(0, 3)(1, 2)

      dict1['s4'] = Permutation(3)(0, 1, 2)

      dict1['s5'] = Permutation(3)(0, 2, 1)

      dict1['s6'] = Permutation(0, 1, 3)

      dict1['s7'] = Permutation(0, 3, 1)

      dict1['s8'] = Permutation(0, 2, 3)

      dict1['s9'] = Permutation(0, 3, 2)

      dict1['s10'] = Permutation(1, 2, 3)

      dict1['s11'] = Permutation(1, 3, 2)
    </input>

    <\unfolded-io|Python] >
      dict1
    <|unfolded-io>
      \ OrderedDict([('e', Permutation(3)), ('s1', Permutation(0, 1)(2, 3)),
      ('s2', Permutation(0, 2)(1, 3)), ('s3', Permutation(0, 3)(1, 2)),
      ('s4', Permutation(3)(0, 1, 2)), ('s5', Permutation(3)(0, 2, 1)),
      ('s6', Permutation(0, 1, 3)), ('s7', Permutation(0, 3, 1)), ('s8',
      Permutation(0, 2, 3)), ('s9', Permutation(0, 3, 2)), ('s10',
      Permutation(1, 2, 3)), ('s11', Permutation(1, 3, 2))])
    </unfolded-io>

    <\input|Python] >
      dict1Inv = dict(zip(dict1.values(),dict1.keys()))
    </input>

    <\unfolded-io|Python] >
      dict1Inv
    <|unfolded-io>
      \ {Permutation(1, 3, 2): 's11', Permutation(0, 1, 3): 's6',
      Permutation(3)(0, 2, 1): 's5', Permutation(3)(0, 1, 2): 's4',
      Permutation(3): 'e', Permutation(0, 1)(2, 3): 's1', Permutation(0,
      2)(1, 3): 's2', Permutation(0, 3)(1, 2): 's3', Permutation(0, 2, 3):
      's8', Permutation(1, 2, 3): 's10', Permutation(0, 3, 2): 's9',
      Permutation(0, 3, 1): 's7'}
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      L = dict1.keys()
    </input>

    <\unfolded-io|Python] >
      L
    <|unfolded-io>
      \ ['e', 's1', 's2', 's3', 's4', 's5', 's6', 's7', 's8', 's9', 's10',
      's11']
    </unfolded-io>

    <\input|Python] >
      m = []
    </input>

    <\input|Python] >
      for i in dict1.values():\ 

      \ \ \ \ m.append([dict1Inv[i*A] for A in dict1.values()])
    </input>

    <\input|Python] >
      \;
    </input>

    <\unfolded-io|Python] >
      TableForm(m, headings=[L, L], wipe_zeros=False)
    <|unfolded-io>
      \ \ \ \ \ \| e \ \ s1 \ s2 \ s3 \ s4 \ s5 \ s6 \ s7 \ s8 \ s9 \ s10 s11

      -----------------------------------------------------

      \ \ e \| e \ \ s1 \ s2 \ s3 \ s4 \ s5 \ s6 \ s7 \ s8 \ s9 \ s10 s11

      \ s1 \| s1 \ e \ \ s3 \ s2 \ s8 \ s10 s9 \ s11 s4 \ s6 \ s5 \ s7\ 

      \ s2 \| s2 \ s3 \ e \ \ s1 \ s11 s6 \ s5 \ s8 \ s7 \ s10 s9 \ s4\ 

      \ s3 \| s3 \ s2 \ s1 \ e \ \ s7 \ s9 \ s10 s4 \ s11 s5 \ s6 \ s8\ 

      \ s4 \| s4 \ s11 s7 \ s8 \ s5 \ e \ \ s3 \ s10 s6 \ s1 \ s2 \ s9\ 

      \ s5 \| s5 \ s9 \ s10 s6 \ e \ \ s4 \ s8 \ s2 \ s3 \ s11 s7 \ s1\ 

      \ s6 \| s6 \ s10 s9 \ s5 \ s2 \ s11 s7 \ e \ \ s1 \ s4 \ s8 \ s3\ 

      \ s7 \| s7 \ s8 \ s4 \ s11 s9 \ s3 \ e \ \ s6 \ s10 s2 \ s1 \ s5\ 

      \ s8 \| s8 \ s7 \ s11 s4 \ s10 s1 \ s2 \ s5 \ s9 \ e \ \ s3 \ s6\ 

      \ s9 \| s9 \ s5 \ s6 \ s10 s3 \ s7 \ s11 s1 \ e \ \ s8 \ s4 \ s2\ 

      s10 \| s10 s6 \ s5 \ s9 \ s1 \ s8 \ s4 \ s3 \ s2 \ s7 \ s11 e \ 

      s11 \| s11 s4 \ s8 \ s7 \ s6 \ s2 \ s1 \ s9 \ s5 \ s3 \ e \ \ s10
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\unfolded-io|Python] >
      for key, value in dict1.items():

      \ \ \ \ print key, ' \ ', value.cyclic_form
    <|unfolded-io>
      e \ \ \ []

      s1 \ \ \ [[0, 1], [2, 3]]

      s2 \ \ \ [[0, 2], [1, 3]]

      s3 \ \ \ [[0, 3], [1, 2]]

      s4 \ \ \ [[0, 1, 2]]

      s5 \ \ \ [[0, 2, 1]]

      s6 \ \ \ [[0, 1, 3]]

      s7 \ \ \ [[0, 3, 1]]

      s8 \ \ \ [[0, 2, 3]]

      s9 \ \ \ [[0, 3, 2]]

      s10 \ \ \ [[1, 2, 3]]

      s11 \ \ \ [[1, 3, 2]]
    </unfolded-io>

    <\unfolded-io|Python] >
      print_cayley_table(dict1.values())
    <|unfolded-io>
      0 1 2 3 4 5 6 7 8 9 10 11

      1 0 3 2 8 10 9 11 4 6 5 7

      2 3 0 1 11 6 5 8 7 10 9 4

      3 2 1 0 7 9 10 4 11 5 6 8

      4 11 7 8 5 0 3 10 6 1 2 9

      5 9 10 6 0 4 8 2 3 11 7 1

      6 10 9 5 2 11 7 0 1 4 8 3

      7 8 4 11 9 3 0 6 10 2 1 5

      8 7 11 4 10 1 2 5 9 0 3 6

      9 5 6 10 3 7 11 1 0 8 4 2

      10 6 5 9 1 8 4 3 2 7 11 0

      11 4 8 7 6 2 1 9 5 3 0 10

      \ None
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      gN = [Permutation(3), Permutation(0, 1)(2, 3), Permutation(0, 2)(1, 3),
      Permutation(0, 3)(1, 2), Permutation(3)(0, 1, 2), Permutation(3)(0, 2,
      1), Permutation(0, 1, 3), Permutation(0, 3, 1), Permutation(0, 2, 3),
      Permutation(0, 3, 2), Permutation(1, 2, 3), Permutation(1, 3, 2)]
    </input>

    <\input|Python] >
      n = len(gN)
    </input>

    <\unfolded-io|Python] >
      n
    <|unfolded-io>
      \ 12
    </unfolded-io>

    <\input|Python] >
      m = []
    </input>

    <\input|Python] >
      for i in gN:\ 

      \ \ \ \ m.append([gN.index(i*A) for A in gN])
    </input>

    <\unfolded-io|Python] >
      TableForm(m, headings=[range(n), range(n)], wipe_zeros=False)
    <|unfolded-io>
      \ \ \ \ \| 0 \ 1 \ 2 \ 3 \ 4 \ 5 \ 6 \ 7 \ 8 \ 9 \ 10 11

      ----------------------------------------

      \ 0 \| 0 \ 1 \ 2 \ 3 \ 4 \ 5 \ 6 \ 7 \ 8 \ 9 \ 10 11

      \ 1 \| 1 \ 0 \ 3 \ 2 \ 8 \ 10 9 \ 11 4 \ 6 \ 5 \ 7\ 

      \ 2 \| 2 \ 3 \ 0 \ 1 \ 11 6 \ 5 \ 8 \ 7 \ 10 9 \ 4\ 

      \ 3 \| 3 \ 2 \ 1 \ 0 \ 7 \ 9 \ 10 4 \ 11 5 \ 6 \ 8\ 

      \ 4 \| 4 \ 11 7 \ 8 \ 5 \ 0 \ 3 \ 10 6 \ 1 \ 2 \ 9\ 

      \ 5 \| 5 \ 9 \ 10 6 \ 0 \ 4 \ 8 \ 2 \ 3 \ 11 7 \ 1\ 

      \ 6 \| 6 \ 10 9 \ 5 \ 2 \ 11 7 \ 0 \ 1 \ 4 \ 8 \ 3\ 

      \ 7 \| 7 \ 8 \ 4 \ 11 9 \ 3 \ 0 \ 6 \ 10 2 \ 1 \ 5\ 

      \ 8 \| 8 \ 7 \ 11 4 \ 10 1 \ 2 \ 5 \ 9 \ 0 \ 3 \ 6\ 

      \ 9 \| 9 \ 5 \ 6 \ 10 3 \ 7 \ 11 1 \ 0 \ 8 \ 4 \ 2\ 

      10 \| 10 6 \ 5 \ 9 \ 1 \ 8 \ 4 \ 3 \ 2 \ 7 \ 11 0\ 

      11 \| 11 4 \ 8 \ 7 \ 6 \ 2 \ 1 \ 9 \ 5 \ 3 \ 0 \ 10
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\unfolded-io|Python] >
      print_cayley_table(gN)
    <|unfolded-io>
      0 1 2 3 4 5 6 7 8 9 10 11

      1 0 3 2 8 10 9 11 4 6 5 7

      2 3 0 1 11 6 5 8 7 10 9 4

      3 2 1 0 7 9 10 4 11 5 6 8

      4 11 7 8 5 0 3 10 6 1 2 9

      5 9 10 6 0 4 8 2 3 11 7 1

      6 10 9 5 2 11 7 0 1 4 8 3

      7 8 4 11 9 3 0 6 10 2 1 5

      8 7 11 4 10 1 2 5 9 0 3 6

      9 5 6 10 3 7 11 1 0 8 4 2

      10 6 5 9 1 8 4 3 2 7 11 0

      11 4 8 7 6 2 1 9 5 3 0 10

      \ None
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      G = symmetric(3)
    </input>

    <\input|Python] >
      g = list(G)
    </input>

    <\unfolded-io|Python] >
      g
    <|unfolded-io>
      \ [Permutation(2), Permutation(1, 2), Permutation(2)(0, 1),
      Permutation(0, 1, 2), Permutation(0, 2, 1), Permutation(0, 2)]
    </unfolded-io>

    <\input|Python] >
      n = len(g)
    </input>

    <\unfolded-io|Python] >
      n
    <|unfolded-io>
      \ 6
    </unfolded-io>

    <\input|Python] >
      m = []
    </input>

    <\input|Python] >
      for i in g:\ 

      \ \ \ \ m.append([g.index(i*A) for A in g])
    </input>

    <\unfolded-io|Python] >
      TableForm(m, headings=[range(n), range(n)], wipe_zeros=False)
    <|unfolded-io>
      \ \ \ \| 0 1 2 3 4 5

      ---------------

      0 \| 0 1 2 3 4 5

      1 \| 1 0 3 2 5 4

      2 \| 2 4 0 5 1 3

      3 \| 3 5 1 4 0 2

      4 \| 4 2 5 0 3 1

      5 \| 5 3 4 1 2 0
    </unfolded-io>

    <\unfolded-io|Python] >
      print_cayley_table(g)
    <|unfolded-io>
      0 1 2 3 4 5

      1 0 3 2 5 4

      2 4 0 5 1 3

      3 5 1 4 0 2

      4 2 5 0 3 1

      5 3 4 1 2 0

      \ None
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      g = CyclicGroup(5)
    </input>

    <\unfolded-io|Python] >
      g.is_group()
    <|unfolded-io>
      \ 0
    </unfolded-io>

    <\unfolded-io|Python] >
      g.order()
    <|unfolded-io>
      \ 5
    </unfolded-io>

    <\unfolded-io|Python] >
      list(g)
    <|unfolded-io>
      \ [Permutation(0, 1, 2, 3, 4)]
    </unfolded-io>

    <\input|Python] >
      def print_cayley_table(G):\ 

      \ \ \ \ o = G.order()

      \ \ \ \ g = G[0].args[0]

      \ \ \ \ g.reverse()

      \ \ \ \ for a in g:\ 

      \ \ \ \ \ \ \ \ for b in g:\ 

      \ \ \ \ \ \ \ \ \ \ \ \ c = a*b\ 

      \ \ \ \ \ \ \ \ \ \ \ \ print c % o,\ 

      \ \ \ \ \ \ \ \ print
    </input>

    <\unfolded-io|Python] >
      print_cayley_table(g)
    <|unfolded-io>
      0 0 0 0 0

      0 1 2 3 4

      0 2 4 1 3

      0 3 1 4 2

      0 4 3 2 1

      \ None
    </unfolded-io>

    <\input|Python] >
      g = g[0].args[0]
    </input>

    <\unfolded-io|Python] >
      g
    <|unfolded-io>
      \ [0, 4, 3, 2, 1]
    </unfolded-io>

    <\unfolded-io|Python] >
      g.reverse()
    <|unfolded-io>
      \ None
    </unfolded-io>

    <\unfolded-io|Python] >
      g
    <|unfolded-io>
      \ [1, 2, 3, 4, 0]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      U6 = [m for m in range(0,6) if gcd(m,6)==1]
    </input>

    <\unfolded-io|Python] >
      U6
    <|unfolded-io>
      \ [1, 5]
    </unfolded-io>

    <\unfolded-io|Python] >
      totient(18)
    <|unfolded-io>
      \ 6
    </unfolded-io>

    <\input|Python] >
      d, u, v = gcdex(11, 18)
    </input>

    <\unfolded-io|Python] >
      d, u, v
    <|unfolded-io>
      \ (5, -3, 1)
    </unfolded-io>

    <\unfolded-io|Python] >
      pow(7, totient(18)-1, 18)
    <|unfolded-io>
      \ 13
    </unfolded-io>

    <\unfolded-io|Python] >
      5 * 11 % 18
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\input|Python] >
      def inverse(a,m):

      \ \ \ \ d, u, v = gcdex(a, m)

      \ \ \ \ if v==1:

      \ \ \ \ \ \ \ \ return d % m \ \ ## return inverse as a number between
      1 and m-1

      \ \ \ \ else:

      \ \ \ \ \ \ \ \ return a, "is not in U group" ## just in case a is not
      in U(m)
    </input>

    <\unfolded-io|Python] >
      inverse(7, 18)
    <|unfolded-io>
      \ 13
    </unfolded-io>

    <\unfolded-io|Python] >
      divisors(totient(18))
    <|unfolded-io>
      \ [1, 2, 3, 6]
    </unfolded-io>

    <\input|Python] >
      def order(a, m):

      \ \ \ \ if gcd(a, m) == 1:

      \ \ \ \ \ \ \ \ for k in divisors(totient(m)):

      \ \ \ \ \ \ \ \ \ \ \ \ if a**k % m == 1:

      \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ return k

      \ \ \ \ else:

      \ \ \ \ \ \ \ \ return a, "is not in U group"
    </input>

    <\unfolded-io|Python] >
      order(11, 18)
    <|unfolded-io>
      \ 6
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      D4 = DihedralGroup(4)
    </input>

    <\unfolded-io|Python] >
      D4
    <|unfolded-io>
      \ PermutationGroup([

      \ \ \ \ Permutation(0, 1, 2, 3),

      \ \ \ \ Permutation(0, 3)(1, 2)])
    </unfolded-io>

    <\unfolded-io|Python] >
      list(D4)
    <|unfolded-io>
      \ [Permutation(0, 1, 2, 3), Permutation(0, 3)(1, 2)]
    </unfolded-io>

    <\input|Python] >
      a = list(D4.generate_dimino())
    </input>

    <\unfolded-io|Python] >
      a
    <|unfolded-io>
      \ [Permutation(3), Permutation(0, 1, 2, 3), Permutation(0, 2)(1, 3),
      Permutation(0, 3, 2, 1), Permutation(0, 3)(1, 2), Permutation(1, 3),
      Permutation(0, 1)(2, 3), Permutation(3)(0, 2)]
    </unfolded-io>

    <\unfolded-io|Python] >
      [perm.cyclic_form for perm in a]
    <|unfolded-io>
      \ [[], [[0, 1, 2, 3]], [[0, 2], [1, 3]], [[0, 3, 2, 1]], [[0, 3], [1,
      2]], [[1, 3]], [[0, 1], [2, 3]], [[0, 2]]]
    </unfolded-io>

    \;

    <\input|Python] >
      symDict = OrderedDict()
    </input>

    <\input|Python] >
      symDict['R0'] = Permutation(3)

      symDict['R90'] = Permutation(0, 1, 2, 3)

      symDict['R180'] = Permutation(0, 2)(1, 3)

      symDict['R270'] = Permutation(0, 3, 2, 1)

      symDict['H'] = Permutation(0, 3)(1, 2)

      symDict['V'] = Permutation(0, 1)(2, 3)

      symDict['D'] = Permutation(1, 3)

      symDict['Dp'] = Permutation(3)(0, 2)
    </input>

    <\unfolded-io|Python] >
      symDict
    <|unfolded-io>
      \ OrderedDict([('R0', Permutation(3)), ('R90', Permutation(0, 1, 2,
      3)), ('R180', Permutation(0, 2)(1, 3)), ('R270', Permutation(0, 3, 2,
      1)), ('H', Permutation(0, 3)(1, 2)), ('V', Permutation(0, 1)(2, 3)),
      ('D', Permutation(1, 3)), ('Dp', Permutation(3)(0, 2))])
    </unfolded-io>

    <\textput>
      \;

      \;

      The following dictionary <with|font-series|bold|p> is the
      <with|font-series|bold|inverse> of <with|font-family|tt|symDict>.

      \;
    </textput>

    <\input|Python] >
      <code*|p = dict(zip(symDict.values(),symDict.keys()))>
    </input>

    <\unfolded-io|Python] >
      p
    <|unfolded-io>
      \ {Permutation(0, 1, 2, 3): 'R90', Permutation(3)(0, 2): 'Dp',
      Permutation(3): 'R0', Permutation(0, 1)(2, 3): 'V', Permutation(0,
      2)(1, 3): 'R180', Permutation(0, 3)(1, 2): 'H', Permutation(1, 3): 'D',
      Permutation(0, 3, 2, 1): 'R270'}
    </unfolded-io>

    <\input|Python] >
      L = symDict.keys()
    </input>

    <\unfolded-io|Python] >
      L
    <|unfolded-io>
      \ ['R0', 'R90', 'R180', 'R270', 'H', 'V', 'D', 'Dp']
    </unfolded-io>

    <\input|Python] >
      n = len(p)
    </input>

    <\unfolded-io|Python] >
      n
    <|unfolded-io>
      \ 8
    </unfolded-io>

    <\input|Python] >
      m = []
    </input>

    <\input|Python] >
      for i in symDict.values():\ 

      \ \ \ \ m.append([ p[i*A] for A in symDict.values() ])
    </input>

    <\unfolded-io|Python] >
      TableForm(m, headings=[L, L], wipe_zeros=False)
    <|unfolded-io>
      \ \ \ \ \ \ \| R0 \ \ R90 \ R180 R270 H \ \ \ V \ \ \ D \ \ \ Dp \ 

      ----------------------------------------------

      \ \ R0 \| R0 \ \ R90 \ R180 R270 H \ \ \ V \ \ \ D \ \ \ Dp \ 

      \ R90 \| R90 \ R180 R270 R0 \ \ Dp \ \ D \ \ \ H \ \ \ V \ \ 

      R180 \| R180 R270 R0 \ \ R90 \ V \ \ \ H \ \ \ Dp \ \ D \ \ 

      R270 \| R270 R0 \ \ R90 \ R180 D \ \ \ Dp \ \ V \ \ \ H \ \ 

      \ \ \ H \| H \ \ \ D \ \ \ V \ \ \ Dp \ \ R0 \ \ R180 R90 \ R270

      \ \ \ V \| V \ \ \ Dp \ \ H \ \ \ D \ \ \ R180 R0 \ \ R270 R90\ 

      \ \ \ D \| D \ \ \ V \ \ \ Dp \ \ H \ \ \ R270 R90 \ R0 \ \ R180

      \ \ Dp \| Dp \ \ H \ \ \ D \ \ \ V \ \ \ R90 \ R270 R180 R0
    </unfolded-io>

    <\unfolded-io|Python] >
      symDict['R90'] * symDict['H']
    <|unfolded-io>
      \ Permutation(3)(0, 2)
    </unfolded-io>

    <\unfolded-io|Python] >
      for key, value in symDict.items():

      \ \ \ \ print key, ' \ \ \ \ ', value.cyclic_form
    <|unfolded-io>
      R0 \ \ \ \ \ \ []

      R90 \ \ \ \ \ \ [[0, 1, 2, 3]]

      R180 \ \ \ \ \ \ [[0, 2], [1, 3]]

      R270 \ \ \ \ \ \ [[0, 3, 2, 1]]

      H \ \ \ \ \ \ [[0, 3], [1, 2]]

      V \ \ \ \ \ \ [[0, 1], [2, 3]]

      D \ \ \ \ \ \ [[1, 3]]

      Dp \ \ \ \ \ \ [[0, 2]]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>
  </session>
</body>

<initial|<\collection>
</collection>>