<TeXmacs|1.0.7.19>

<style|generic>

<\body>
  <\session|python|default>
    <\output>
      Python plugin for TeXmacs.

      Please see the documentation in Help -\<gtr\> plugins -\<gtr\> Python
    </output>

    <\input|Python] >
      from sympy import *
    </input>

    <\unfolded-io|Python] >
      var('a:z')
    <|unfolded-io>
      \ (a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u, v, w,
      x, y, z)
    </unfolded-io>

    <\input|Python] >
      from sympy.combinatorics.permutations import *
    </input>

    <\input|Python] >
      import itertools
    </input>

    <\input|Python] >
      from sympy.combinatorics.generators import symmetric, alternating
    </input>

    <\input|Python] >
      from sympy.combinatorics import PermutationGroup
    </input>

    <\input|Python] >
      from sympy.combinatorics.polyhedron import tetrahedron
    </input>

    <\input|Python] >
      from sympy.combinatorics.named_groups import *
    </input>

    <\input|Python] >
      from sympy.ntheory import *
    </input>

    <\input|Python] >
      <\code>
        <code*|from collections import OrderedDict>
      </code>
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      g = range(100)
    </input>

    <\unfolded-io|Python] >
      g.index(8*4)
    <|unfolded-io>
      \ 32
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      def print_cayley_table(G):\ 

      \ \ \ \ for a in G:\ 

      \ \ \ \ \ \ \ \ for b in G:\ 

      \ \ \ \ \ \ \ \ \ \ \ \ c = a*b\ 

      \ \ \ \ \ \ \ \ \ \ \ \ print G.index(c),\ 

      \ \ \ \ \ \ \ \ print
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      s3 = symmetric(3)
    </input>

    <\unfolded-io|Python] >
      type(s3)
    <|unfolded-io>
      \ \<less\>type 'generator'\<gtr\>
    </unfolded-io>

    <\unfolded-io|Python] >
      list(s3)
    <|unfolded-io>
      \ [Permutation(2), Permutation(1, 2), Permutation(2)(0, 1),
      Permutation(0, 1, 2), Permutation(0, 2, 1), Permutation(0, 2)]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      S3 = SymmetricGroup(3)
    </input>

    <\unfolded-io|Python] >
      type(S3)
    <|unfolded-io>
      \ \<less\>class 'sympy.combinatorics.perm_groups.PermutationGroup'\<gtr\>
    </unfolded-io>

    <\unfolded-io|Python] >
      S3
    <|unfolded-io>
      \ PermutationGroup([

      \ \ \ \ Permutation(0, 1, 2),

      \ \ \ \ Permutation(2)(0, 1)])
    </unfolded-io>

    <\unfolded-io|Python] >
      S3.generators
    <|unfolded-io>
      \ [Permutation(0, 1, 2), Permutation(2)(0, 1)]
    </unfolded-io>

    <\input|Python] >
      H = PermutationGroup([Permutation(0, 1, 2), Permutation(2)(0, 1)])
    </input>

    <\unfolded-io|Python] >
      H == S3
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\unfolded-io|Python] >
      list(S3)
    <|unfolded-io>
      \ [Permutation(0, 1, 2), Permutation(2)(0, 1)]
    </unfolded-io>

    <\unfolded-io|Python] >
      list( S3.generate_dimino() )
    <|unfolded-io>
      \ [Permutation(2), Permutation(0, 1, 2), Permutation(0, 2, 1),
      Permutation(2)(0, 1), Permutation(0, 2), Permutation(1, 2)]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      G = PermutationGroup([Permutation(2), Permutation(0, 1, 2),
      Permutation(0, 2, 1)])
    </input>

    <\unfolded-io|Python] >
      G.is_group()
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\unfolded-io|Python] >
      G.is_subgroup(S3)
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\unfolded-io|Python] >
      G.generators
    <|unfolded-io>
      \ [Permutation(2), Permutation(0, 1, 2), Permutation(0, 2, 1)]
    </unfolded-io>

    <\unfolded-io|Python] >
      Permutation(0, 1, 2)**3
    <|unfolded-io>
      \ Permutation(2)
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      H = PermutationGroup([Permutation(2), Permutation(1, 2)])
    </input>

    <\unfolded-io|Python] >
      type(H)
    <|unfolded-io>
      \ \<less\>class 'sympy.combinatorics.perm_groups.PermutationGroup'\<gtr\>
    </unfolded-io>

    <\unfolded-io|Python] >
      H.is_group()
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\unfolded-io|Python] >
      list(H)
    <|unfolded-io>
      \ [Permutation(2), Permutation(1, 2)]
    </unfolded-io>

    <\unfolded-io|Python] >
      list(H.generate_dimino())
    <|unfolded-io>
      \ [Permutation(2), Permutation(1, 2)]
    </unfolded-io>

    <\input|Python] >
      G = PermutationGroup([Permutation(1, 2)])
    </input>

    <\unfolded-io|Python] >
      G.is_group()
    <|unfolded-io>
      \ 0
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      S4 = SymmetricGroup(4)
    </input>

    <\unfolded-io|Python] >
      type(S4)
    <|unfolded-io>
      \ \<less\>class 'sympy.combinatorics.perm_groups.PermutationGroup'\<gtr\>
    </unfolded-io>

    <\unfolded-io|Python] >
      S4
    <|unfolded-io>
      \ PermutationGroup([

      \ \ \ \ Permutation(0, 1, 2, 3),

      \ \ \ \ Permutation(3)(0, 1)])
    </unfolded-io>

    <\unfolded-io|Python] >
      list(S4)
    <|unfolded-io>
      \ [Permutation(0, 1, 2, 3), Permutation(3)(0, 1)]
    </unfolded-io>

    <\unfolded-io|Python] >
      list( S4.generate_dimino() )
    <|unfolded-io>
      \ [Permutation(3), Permutation(0, 1, 2, 3), Permutation(0, 2)(1, 3),
      Permutation(0, 3, 2, 1), Permutation(3)(0, 1), Permutation(0, 2, 3),
      Permutation(0, 3, 1, 2), Permutation(1, 3, 2), Permutation(1, 2, 3),
      Permutation(0, 1, 3, 2), Permutation(3)(0, 2, 1), Permutation(0, 3),
      Permutation(0, 2, 1, 3), Permutation(0, 3, 1), Permutation(2, 3),
      Permutation(3)(0, 1, 2), Permutation(0, 2, 3, 1), Permutation(0, 3, 2),
      Permutation(3)(1, 2), Permutation(0, 1, 3), Permutation(0, 3)(1, 2),
      Permutation(1, 3), Permutation(0, 1)(2, 3), Permutation(3)(0, 2)]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      G = PermutationGroup([Permutation(3), Permutation(0, 1, 2, 3),
      Permutation(0, 3, 2, 1), Permutation(0, 2)(1, 3), Permutation(0, 3)(1,
      2), Permutation(0, 1)(2, 3), Permutation(1, 3), Permutation(3)(0, 2)])
    </input>

    <\unfolded-io|Python] >
      G.is_group()
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\unfolded-io|Python] >
      G.is_subgroup(S4)
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\unfolded-io|Python] >
      G.generators
    <|unfolded-io>
      \ [Permutation(3), Permutation(0, 1, 2, 3), Permutation(0, 3, 2, 1),
      Permutation(0, 2)(1, 3), Permutation(0, 3)(1, 2), Permutation(0, 1)(2,
      3), Permutation(1, 3), Permutation(3)(0, 2)]
    </unfolded-io>

    <\unfolded-io|Python] >
      S4.generators
    <|unfolded-io>
      \ [Permutation(0, 1, 2, 3), Permutation(3)(0, 1)]
    </unfolded-io>

    <\input|Python] >
      H = PermutationGroup([Permutation(0, 1, 2, 3), Permutation(3)(0, 1)])
    </input>

    <\unfolded-io|Python] >
      H == S4
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      S10 = SymmetricGroup(10)
    </input>

    <\unfolded-io|Python] >
      S10
    <|unfolded-io>
      \ PermutationGroup([

      \ \ \ \ Permutation(0, 1, 2, 3, 4, 5, 6, 7, 8, 9),

      \ \ \ \ Permutation(9)(0, 1)])
    </unfolded-io>

    <\input|Python] >
      a = Permutation(9)(0, 1)
    </input>

    <\input|Python] >
      b = Permutation(9)(0, 4, 2)(1, 3)
    </input>

    <\input|Python] >
      H = PermutationGroup([a, b])
    </input>

    <\unfolded-io|Python] >
      H
    <|unfolded-io>
      \ PermutationGroup([

      \ \ \ \ Permutation(9)(0, 1),

      \ \ \ \ Permutation(9)(0, 4, 2)(1, 3)])
    </unfolded-io>

    <\input|Python] >
      h = H.generate_dimino()
    </input>

    <\input|Python] >
      hL = list(h)
    </input>

    <\unfolded-io|Python] >
      H.is_subgroup(S10)
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\unfolded-io|Python] >
      H.order()
    <|unfolded-io>
      \ 120
    </unfolded-io>

    <\unfolded-io|Python] >
      a * b * a * b**2
    <|unfolded-io>
      \ Permutation(9)(0, 3, 2, 1)
    </unfolded-io>

    <\unfolded-io|Python] >
      Permutation(9)(0, 3, 2, 1) in hL
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\unfolded-io|Python] >
      Permutation(7, 8, 9) in hL
    <|unfolded-io>
      \ 0
    </unfolded-io>

    <\unfolded-io|Python] >
      3 in [1, 2, 3]
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      A3 = AlternatingGroup(3)
    </input>

    <\unfolded-io|Python] >
      list(A3.generate_dimino())
    <|unfolded-io>
      \ [Permutation(2), Permutation(0, 1, 2), Permutation(0, 2, 1)]
    </unfolded-io>

    <\input|Python] >
      G = A3.center()
    </input>

    <\unfolded-io|Python] >
      G
    <|unfolded-io>
      \ PermutationGroup([

      \ \ \ \ Permutation(2),

      \ \ \ \ Permutation(0, 1, 2),

      \ \ \ \ Permutation(0, 2, 1)])
    </unfolded-io>

    <\unfolded-io|Python] >
      G.is_subgroup(A3)
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      n = 20
    </input>

    <\input|Python] >
      Cn = CyclicGroup(n)
    </input>

    <\input|Python] >
      list( Cn.generate_dimino() );
    </input>

    <\input|Python] >
      element_orders = set([g.order() for g in list( Cn.generate_dimino() )])
    </input>

    <\unfolded-io|Python] >
      element_orders
    <|unfolded-io>
      \ set([1, 20, 10, 2, 4, 5])
    </unfolded-io>

    <\unfolded-io|Python] >
      Cn.order()
    <|unfolded-io>
      \ 20
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    \;

    \;
  </session>
</body>

<initial|<\collection>
</collection>>