<TeXmacs|1.0.7.19>

<style|generic>

<\body>
  <\session|python|default>
    <\output>
      Python plugin for TeXmacs.

      Please see the documentation in Help -\<gtr\> plugins -\<gtr\> Python
    </output>

    <\input|Python] >
      from sympy import *
    </input>

    <\unfolded-io|Python] >
      var('a:z')
    <|unfolded-io>
      \ (a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u, v, w,
      x, y, z)
    </unfolded-io>

    <\unfolded-io|Python] >
      var('A:Z')
    <|unfolded-io>
      \ (A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S, T, U, V, W,
      X, Y, Z)
    </unfolded-io>

    <\input|Python] >
      from sympy.combinatorics.permutations import *
    </input>

    <\input|Python] >
      import itertools
    </input>

    <\input|Python] >
      from sympy.combinatorics.generators import symmetric, alternating
    </input>

    <\input|Python] >
      from sympy.combinatorics.perm_groups import PermutationGroup
    </input>

    <\input|Python] >
      from sympy.combinatorics.polyhedron import tetrahedron
    </input>

    <\input|Python] >
      <with|font-series|bold|from sympy.combinatorics.named_groups import *>
    </input>

    <\input|Python] >
      from sympy.ntheory import *
    </input>

    <\input|Python] >
      <\code>
        <code*|from collections import OrderedDict>
      </code>
    </input>

    <\input|Python] >
      from sympy.combinatorics import Polyhedron, Permutation
    </input>

    <\input|Python] >
      from sympy.combinatorics.polyhedron import cube
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      g = range(100)
    </input>

    <\unfolded-io|Python] >
      g.index(8*4)
    <|unfolded-io>
      \ 32
    </unfolded-io>

    <\unfolded-io|Python] >
      cube.corners
    <|unfolded-io>
      \ (0, 1, 2, 3, 4, 5, 6, 7)
    </unfolded-io>

    <\unfolded-io|Python] >
      cube.vertices
    <|unfolded-io>
      \ (0, 1, 2, 3, 4, 5, 6, 7)
    </unfolded-io>

    <\input|Python] >
      p = Polyhedron(list('abcdefgh'))
    </input>

    <\unfolded-io|Python] >
      p.corners
    <|unfolded-io>
      \ (a, b, c, d, e, f, g, h)
    </unfolded-io>

    <\unfolded-io|Python] >
      p.vertices
    <|unfolded-io>
      \ (a, b, c, d, e, f, g, h)
    </unfolded-io>

    <\unfolded-io|Python] >
      cube.array_form
    <|unfolded-io>
      \ [0, 1, 2, 3, 4, 5, 6, 7]
    </unfolded-io>

    <\unfolded-io|Python] >
      cube.edges
    <|unfolded-io>
      \ {(0, 1), (0, 3), (0, 4), ..., (4, 7), (5, 6), (6, 7)}
    </unfolded-io>

    <\unfolded-io|Python] >
      cube.faces
    <|unfolded-io>
      \ {(0, 1, 2, 3), (0, 1, 5, 4), (0, 3, 7, 4), (1, 2, 6, 5), (2, 3, 7,
      6), (4, 5, 6, 7)}
    </unfolded-io>

    <\unfolded-io|Python] >
      cube.pgroup
    <|unfolded-io>
      \ PermutationGroup([

      \ \ \ \ Permutation(0, 1, 2, 3)(4, 5, 6, 7),

      \ \ \ \ Permutation(0, 4, 5, 1)(2, 3, 7, 6),

      \ \ \ \ Permutation(0, 4, 7, 3)(1, 5, 6, 2),

      \ \ \ \ Permutation(0, 1)(2, 4)(3, 5)(6, 7),

      \ \ \ \ Permutation(0, 6)(1, 2)(3, 5)(4, 7),

      \ \ \ \ Permutation(0, 6)(1, 7)(2, 3)(4, 5),

      \ \ \ \ Permutation(0, 3)(1, 7)(2, 4)(5, 6),

      \ \ \ \ Permutation(0, 4)(1, 7)(2, 6)(3, 5),

      \ \ \ \ Permutation(0, 6)(1, 5)(2, 4)(3, 7),

      \ \ \ \ Permutation(1, 3, 4)(2, 7, 5),

      \ \ \ \ Permutation(7)(0, 5, 2)(3, 4, 6),

      \ \ \ \ Permutation(0, 5, 7)(1, 6, 3),

      \ \ \ \ Permutation(0, 7, 2)(1, 4, 6)])
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\textput>
      \;

      <\with|font-series|bold>
        3-Cube Group <emdash> <math|RC<rsub|3>> can be represented by the
        group subgroup of <math|S<rsub|48>>

        \;
      </with>
    </textput>

    <\input|Python] >
      S48 = SymmetricGroup(48)
    </input>

    <\unfolded-io|Python] >
      S48.order()
    <|unfolded-io>
      \ 12413915592536072670862289047373375038521486354677760000000000
    </unfolded-io>

    <\unfolded-io|Python] >
      S48.generators
    <|unfolded-io>
      \ [Permutation(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15,
      16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33,
      34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47),
      Permutation(47)(0, 1)]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      c48 = S48.center()
    </input>

    <\unfolded-io|Python] >
      c48.is_subgroup(S48)
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\textput>
      \;

      <with|font-series|bold|First 6 equations are minus one>

      \;
    </textput>

    <\input|Python] >
      R = Permutation(24, 26, 31, 29)(25, 28, 30, 27)(2, 37, 42, 18)(4, 35,
      44, 20)(7, 32, 47, 23)
    </input>

    <\input|Python] >
      L = Permutation(47)(8, 10, 15, 13)(9, 12, 14, 11)(0, 16, 40, 39)(3, 19,
      43, 36)(5, 21, 45, 34)
    </input>

    <\input|Python] >
      U = Permutation(47)(0, 2, 7, 5)(1, 4, 6, 3)(8, 32, 24, 16)(9, 33, 25,
      17)(10, 34, 26, 18)
    </input>

    <\input|Python] >
      D = Permutation(40, 42, 47, 45)(41, 44, 46, 43)(13, 21, 29, 37)(14, 22,
      30, 38)(15, 23, 31, 39)
    </input>

    <\input|Python] >
      F = Permutation(47)(16, 18, 23, 21)(17, 20, 22, 19)(5, 24, 42, 15)(6,
      27, 41, 12)(7, 29, 40, 10)
    </input>

    <\input|Python] >
      B = Permutation(32, 34, 39, 37)(33, 36, 38, 35)(2, 8, 45, 31)(1, 11,
      46, 28)(0, 13, 47, 26)
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      RC3 = PermutationGroup([R, L, U, D, F, B])
    </input>

    <\unfolded-io|Python] >
      RC3.generators
    <|unfolded-io>
      \ [Permutation(2, 37, 42, 18)(4, 35, 44, 20)(7, 32, 47, 23)(24, 26, 31,
      29)(25, 28, 30, 27), Permutation(47)(0, 16, 40, 39)(3, 19, 43, 36)(5,
      21, 45, 34)(8, 10, 15, 13)(9, 12, 14, 11), Permutation(47)(0, 2, 7,
      5)(1, 4, 6, 3)(8, 32, 24, 16)(9, 33, 25, 17)(10, 34, 26, 18),
      Permutation(13, 21, 29, 37)(14, 22, 30, 38)(15, 23, 31, 39)(40, 42, 47,
      45)(41, 44, 46, 43), Permutation(47)(5, 24, 42, 15)(6, 27, 41, 12)(7,
      29, 40, 10)(16, 18, 23, 21)(17, 20, 22, 19), Permutation(0, 13, 47,
      26)(1, 11, 46, 28)(2, 8, 45, 31)(32, 34, 39, 37)(33, 36, 38, 35)]
    </unfolded-io>

    <\unfolded-io|Python] >
      RC3.is_subgroup(S48)
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\unfolded-io|Python] >
      type(RC3)
    <|unfolded-io>
      \ \<less\>class 'sympy.combinatorics.perm_groups.PermutationGroup'\<gtr\>
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      rc3 = RC3.generate_dimino()
    </input>

    \;

    <\unfolded-io|Python] >
      R**(-1)
    <|unfolded-io>
      \ Permutation(2, 18, 42, 37)(4, 20, 44, 35)(7, 23, 47, 32)(24, 29, 31,
      26)(25, 27, 30, 28)
    </unfolded-io>

    <\unfolded-io|Python] >
      R**(-1) in S48.generate_dimino()
    <|unfolded-io>
      <script-busy>
    </unfolded-io>

    <\unfolded-io|Python] >
      RC3.is_group()
    <|unfolded-io>
      \ 0
    </unfolded-io>

    <\unfolded-io|Python] >
      RC3.is_subgroup(S48)
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\unfolded-io|Python] >
      RC3.order()
    <|unfolded-io>
      \ 43252003274489856000
    </unfolded-io>

    <\unfolded-io|Python] >
      factorint(RC3.order())
    <|unfolded-io>
      \ {11: 1, 2: 27, 3: 14, 5: 3, 7: 2}
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\unfolded-io|Python] >
      Permutation(6, 17) in RC3
    <|unfolded-io>
      \ 0
    </unfolded-io>

    <\unfolded-io|Python] >
      Permutation(6, 17)(4, 25) in RC3
    <|unfolded-io>
      \ 0
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    \;
  </session>
</body>

<initial|<\collection>
</collection>>