<TeXmacs|1.0.7.19>

<style|generic>

<\body>
  <\session|python|default>
    <\output>
      Python plugin for TeXmacs.

      Please see the documentation in Help -\> plugins -\> Python
    </output>

    <\input|Python] >
      from sympy import *
    </input>

    <\unfolded-io|Python] >
      var('a:z')
    <|unfolded-io>
      \ (a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u, v, w,
      x, y, z)
    </unfolded-io>

    <\input|Python] >
      s1 = set([1, 2, 3, 4, 5])\ 
    </input>

    <\input|Python] >
      s2 = set([1, 2, 3, 6, 7])
    </input>

    <\unfolded-io|Python] >
      list( ProductSet(s1, s2) )
    <|unfolded-io>
      Traceback (most recent call last):

      TypeError: Input must be Sets or iterables of Sets
    </unfolded-io>

    <\input|Python] >
      s1 = FiniteSet([1, 2, 3, 4, 5])
    </input>

    <\input|Python] >
      s2 = FiniteSet([1, 2, 3, 6, 7])
    </input>

    <\unfolded-io|Python] >
      ProductSet(s1, s2)
    <|unfolded-io>
      \ {1, 2, 3, 4, 5} x {1, 2, 3, 6, 7}
    </unfolded-io>

    <\unfolded-io|Python] >
      list( ProductSet(s1, s2) )
    <|unfolded-io>
      \ [(1, 1), (1, 2), (1, 7), (1, 3), (1, 6), (2, 1), (2, 2), (2, 7), (2,
      3), (2, 6), (4, 1), (4, 2), (4, 7), (4, 3), (4, 6), (3, 1), (3, 2), (3,
      7), (3, 3), (3, 6), (5, 1), (5, 2), (5, 7), (5, 3), (5, 6)]
    </unfolded-io>

    <\unfolded-io|Python] >
      s1
    <|unfolded-io>
      \ set([1, 2, 3, 4, 5])
    </unfolded-io>

    <\unfolded-io|Python] >
      s1.union(s2)
    <|unfolded-io>
      \ set([1, 2, 3, 4, 5, 6, 7])
    </unfolded-io>

    <\unfolded-io|Python] >
      s1.intersection(s2)
    <|unfolded-io>
      \ set([3, 4, 5])
    </unfolded-io>

    <\unfolded-io|Python] >
      s2.difference(s1)
    <|unfolded-io>
      \ set([6, 7])
    </unfolded-io>

    <\unfolded-io|Python] >
      2 in s1
    <|unfolded-io>
      \ 1in QQ
    </unfolded-io>

    <\unfolded-io|Python] >
      7 in s1
    <|unfolded-io>
      \ 0
    </unfolded-io>

    <\unfolded-io|Python] >
      S(1)/3 in ZZ
    <|unfolded-io>
      \ 0
    </unfolded-io>

    <\input|Python] >
      NN = S.Naturals
    </input>

    <\unfolded-io|Python] >
      -1 in NN
    <|unfolded-io>
      \ 0
    </unfolded-io>

    <\unfolded-io|Python] >
      0 in NN
    <|unfolded-io>
      \ 0
    </unfolded-io>

    <\unfolded-io|Python] >
      0 in S.Naturals0
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\input|Python] >
      squares = ImageSet(Lambda(x, x**2), NN)
    </input>

    <\unfolded-io|Python] >
      5 in squares
    <|unfolded-io>
      \ 0
    </unfolded-io>

    <\unfolded-io|Python] >
      9 in squares
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\unfolded-io|Python] >
      FiniteSet(0, 1, 2, 3, 4, 5, 6, 7, 9, 10).intersect(squares)
    <|unfolded-io>
      \ {1, 4, 9}
    </unfolded-io>

    <\unfolded-io|Python] >
      -1 in RR
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\unfolded-io|Python] >
      S(1) / 3 in QQ
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\unfolded-io|Python] >
      3 in QQ
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\unfolded-io|Python] >
      set(x for x in range(10) if x%2 == 1)
    <|unfolded-io>
      \ set([1, 3, 9, 5, 7])
    </unfolded-io>

    <\unfolded-io|Python] >
      set(x for x in range(10) if x%2 == 0)
    <|unfolded-io>
      \ set([0, 8, 2, 4, 6])
    </unfolded-io>

    <\unfolded-io|Python] >
      isprime(29)
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\unfolded-io|Python] >
      set(x for x in range(10) if isprime(x))
    <|unfolded-io>
      \ set([2, 3, 5, 7])
    </unfolded-io>

    <\unfolded-io|Python] >
      len( \ \ set(x for x in range(1000) if isprime(x)) \ \ )
    <|unfolded-io>
      \ 168
    </unfolded-io>

    <\input|Python] >
      S1 = set( range(20) )
    </input>

    <\unfolded-io|Python] >
      S1
    <|unfolded-io>
      \ set([0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17,
      18, 19])
    </unfolded-io>

    <\unfolded-io|Python] >
      filter(isprime, list(S1) )
    <|unfolded-io>
      \ [2, 3, 5, 7, 11, 13, 17, 19]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>
  </session>
</body>

<\initial>
  <\collection>
    <associate|language|american>
    <associate|page-type|letter>
  </collection>
</initial>