<TeXmacs|1.0.7.18>

<style|generic>

<\body>
  <\session|python|default>
    <\output>
      Python plugin for TeXmacs.

      Please see the documentation in Help -\<gtr\> plugins -\<gtr\> Python
    </output>

    <\input|Python] >
      from sympy import *
    </input>

    <\unfolded-io|Python] >
      var('a:z')
    <|unfolded-io>
      \ (a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u, v, w,
      x, y, z)
    </unfolded-io>

    <\input|Python] >
      from sympy.combinatorics.permutations import *
    </input>

    <\input|Python] >
      import itertools
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      p = Permutation([0,1,2,3])
    </input>

    <\unfolded-io|Python] >
      p(3)
    <|unfolded-io>
      \ 3
    </unfolded-io>

    <\unfolded-io|Python] >
      p.size
    <|unfolded-io>
      \ 4
    </unfolded-io>

    <\unfolded-io|Python] >
      p.cardinality
    <|unfolded-io>
      \ 24
    </unfolded-io>

    <\input|Python] >
      permList = list(itertools.permutations(p))
    </input>

    <\unfolded-io|Python] >
      permList
    <|unfolded-io>
      \ [(0, 1, 2, 3), (0, 1, 3, 2), (0, 2, 1, 3), (0, 2, 3, 1), (0, 3, 1,
      2), (0, 3, 2, 1), (1, 0, 2, 3), (1, 0, 3, 2), (1, 2, 0, 3), (1, 2, 3,
      0), (1, 3, 0, 2), (1, 3, 2, 0), (2, 0, 1, 3), (2, 0, 3, 1), (2, 1, 0,
      3), (2, 1, 3, 0), (2, 3, 0, 1), (2, 3, 1, 0), (3, 0, 1, 2), (3, 0, 2,
      1), (3, 1, 0, 2), (3, 1, 2, 0), (3, 2, 0, 1), (3, 2, 1, 0)]
    </unfolded-io>

    <\unfolded-io|Python] >
      len(permList)
    <|unfolded-io>
      \ 24
    </unfolded-io>

    <\unfolded-io|Python] >
      [i^p for i in range(p.size)]
    <|unfolded-io>
      \ [0, 1, 2, 3]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      terms=[0,1,2]
    </input>

    <\input|Python] >
      q = Permutation(terms)
    </input>

    <\unfolded-io|Python] >
      q(2)
    <|unfolded-io>
      \ 2
    </unfolded-io>

    <\unfolded-io|Python] >
      list(itertools.permutations (q))
    <|unfolded-io>
      \ [(0, 1, 2), (0, 2, 1), (1, 0, 2), (1, 2, 0), (2, 0, 1), (2, 1, 0)]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      terms = [a, a, b, b]
    </input>

    <\input|Python] >
      r = list( itertools.permutations(terms) )
    </input>

    <\unfolded-io|Python] >
      r
    <|unfolded-io>
      \ [(a, a, b, b), (a, a, b, b), (a, b, a, b), (a, b, b, a), (a, b, a,
      b), (a, b, b, a), (a, a, b, b), (a, a, b, b), (a, b, a, b), (a, b, b,
      a), (a, b, a, b), (a, b, b, a), (b, a, a, b), (b, a, b, a), (b, a, a,
      b), (b, a, b, a), (b, b, a, a), (b, b, a, a), (b, a, a, b), (b, a, b,
      a), (b, a, a, b), (b, a, b, a), (b, b, a, a), (b, b, a, a)]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      a = Permutation([1, 0, 2])
    </input>

    <\unfolded-io|Python] >
      a(1)
    <|unfolded-io>
      \ 0
    </unfolded-io>

    <\unfolded-io|Python] >
      pprint( Matrix([[0, 1, 2],[a(i) for i in range(3)]]) )
    <|unfolded-io>
      [0 \ 1 \ 2]

      [ \ \ \ \ \ \ ]

      [1 \ 0 \ 2]

      \ None
    </unfolded-io>

    <\input|Python] >
      a = Permutation([4, 2, 0, 3, 1])
    </input>

    <\input|Python] >
      b = Permutation([4, 2, 1, 0, 3])
    </input>

    <\unfolded-io|Python] >
      [i^a for i in range(a.size)]
    <|unfolded-io>
      \ [4, 2, 0, 3, 1]
    </unfolded-io>

    <\unfolded-io|Python] >
      (a * b).array_form
    <|unfolded-io>
      \ [3, 1, 4, 0, 2]
    </unfolded-io>

    <\unfolded-io|Python] >
      (b * a).array_form
    <|unfolded-io>
      \ [1, 0, 2, 4, 3]
    </unfolded-io>

    <\unfolded-io|Python] >
      (a**(-1)).array_form
    <|unfolded-io>
      \ [2, 4, 1, 3, 0]
    </unfolded-io>

    <\unfolded-io|Python] >
      a * b
    <|unfolded-io>
      \ Permutation(0, 3)(2, 4)
    </unfolded-io>

    <\input|Python] >
      \;
    </input>
  </session>
</body>

<initial|<\collection>
</collection>>