<TeXmacs|1.0.7.19>

<style|generic>

<\body>
  <\session|python|default>
    <\output>
      Python plugin for TeXmacs.

      Please see the documentation in Help -\<gtr\> plugins -\<gtr\> Python
    </output>

    <\input|Python] >
      from sympy import *
    </input>

    <\unfolded-io|Python] >
      var('a:z')
    <|unfolded-io>
      \ (a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u, v, w,
      x, y, z)
    </unfolded-io>

    <\input|Python] >
      from sympy.combinatorics.permutations import *
    </input>

    <\input|Python] >
      import itertools
    </input>

    <\input|Python] >
      from sympy.combinatorics.generators import symmetric
    </input>

    <\input|Python] >
      \;
    </input>

    <\unfolded-io|Python] >
      set([a, b, c]) == set([b, c, a])
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\unfolded-io|Python] >
      [a, b, c] == [b, c, a]
    <|unfolded-io>
      \ 0
    </unfolded-io>

    <\unfolded-io|Python] >
      Permutation(1, 2)(3, 5) == Permutation([[1, 2], [3, 5]])
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\input|Python] >
      p = Permutation([0,1,2,3])
    </input>

    <\unfolded-io|Python] >
      Cycle(p)
    <|unfolded-io>
      \ Cycle()
    </unfolded-io>

    <\input|Python] >
      I = Permutation([0,1,2,3])
    </input>

    <\unfolded-io|Python] >
      I
    <|unfolded-io>
      \ Permutation(3)
    </unfolded-io>

    <\unfolded-io|Python] >
      I == Permutation(range(4))
    <|unfolded-io>
      \ 1
    </unfolded-io>

    <\unfolded-io|Python] >
      I == Permutation( [range(4)] )
    <|unfolded-io>
      \ 0
    </unfolded-io>

    <\input|Python] >
      Permutation.print_cyclic = True
    </input>

    <\unfolded-io|Python] >
      Permutation([0, 2, 1, 4, 5, 3])
    <|unfolded-io>
      \ Permutation(1, 2)(3, 4, 5)
    </unfolded-io>

    <\input|Python] >
      Permutation.print_cyclic = False
    </input>

    <\unfolded-io|Python] >
      Permutation([0, 2, 1, 4, 5, 3])
    <|unfolded-io>
      \ Permutation([0, 2, 1, 4, 5, 3])
    </unfolded-io>

    <\input|Python] >
      p = Permutation([0, 2, 1, 4, 5, 3])
    </input>

    <\unfolded-io|Python] >
      p.array_form
    <|unfolded-io>
      \ [0, 2, 1, 4, 5, 3]
    </unfolded-io>

    <\unfolded-io|Python] >
      p.cyclic_form
    <|unfolded-io>
      \ [[1, 2], [3, 4, 5]]
    </unfolded-io>

    <\unfolded-io|Python] >
      p.full_cyclic_form
    <|unfolded-io>
      \ [[0], [1, 2], [3, 4, 5]]
    </unfolded-io>

    <\unfolded-io|Python] >
      dict([(i, p(i)) for i in range(p.size)])
    <|unfolded-io>
      \ {0: 0, 1: 2, 2: 1, 3: 4, 4: 5, 5: 3}
    </unfolded-io>

    <\unfolded-io|Python] >
      p.size
    <|unfolded-io>
      \ 6
    </unfolded-io>

    <\unfolded-io|Python] >
      p.cardinality
    <|unfolded-io>
      \ 720
    </unfolded-io>

    <\unfolded-io|Python] >
      p.index()
    <|unfolded-io>
      \ 5
    </unfolded-io>

    <\input|Python] >
      q = Permutation([5, 1, 6, 8, 4, 0, 7, 2, 9, 3])
    </input>

    <\unfolded-io|Python] >
      q.cyclic_form
    <|unfolded-io>
      \ [[0, 5], [2, 6, 7], [3, 8, 9]]
    </unfolded-io>

    <\unfolded-io|Python] >
      q.full_cyclic_form
    <|unfolded-io>
      \ [[0, 5], [1], [2, 6, 7], [3, 8, 9], [4]]
    </unfolded-io>

    <\unfolded-io|Python] >
      Permutation([3, 0, 1, 2]).cyclic_form
    <|unfolded-io>
      \ [[0, 3, 2, 1]]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\unfolded-io|Python] >
      p * q
    <|unfolded-io>
      \ Permutation([5, 6, 1, 4, 0, 8, 7, 2, 9, 3])
    </unfolded-io>

    <\unfolded-io|Python] >
      ( p * q ).cyclic_form
    <|unfolded-io>
      \ [[0, 5, 8, 9, 3, 4], [1, 6, 7, 2]]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\unfolded-io|Python] >
      list( symmetric(3) )
    <|unfolded-io>
      \ [Permutation([0, 1, 2]), Permutation([0, 2, 1]), Permutation([1, 0,
      2]), Permutation([1, 2, 0]), Permutation([2, 0, 1]), Permutation([2, 1,
      0])]
    </unfolded-io>

    <\unfolded-io|Python] >
      len( list( symmetric(3) ) )
    <|unfolded-io>
      \ 6
    </unfolded-io>

    <\unfolded-io|Python] >
      for i in range(len(list(symmetric(3)))):

      \ \ \ \ print list(symmetric(3))[i].array_form
    <|unfolded-io>
      [0, 1, 2]

      [0, 2, 1]

      [1, 0, 2]

      [1, 2, 0]

      [2, 0, 1]

      [2, 1, 0]
    </unfolded-io>

    <\unfolded-io|Python] >
      for i in range(len(list(symmetric(3)))):

      \ \ \ \ print list(symmetric(3))[i].cyclic_form
    <|unfolded-io>
      []

      [[1, 2]]

      [[0, 1]]

      [[0, 1, 2]]

      [[0, 2, 1]]

      [[0, 2]]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      p = Permutation (1, 3, 5, 2)(4, 7)
    </input>

    <\unfolded-io|Python] >
      p
    <|unfolded-io>
      \ Permutation([0, 3, 1, 5, 7, 2, 6, 4])
    </unfolded-io>

    <\unfolded-io|Python] >
      p.array_form
    <|unfolded-io>
      \ [0, 3, 1, 5, 7, 2, 6, 4]
    </unfolded-io>

    <\unfolded-io|Python] >
      p.cyclic_form
    <|unfolded-io>
      \ [[1, 3, 5, 2], [4, 7]]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      a = Permutation (1, 5, 2, 3)
    </input>

    <\input|Python] >
      b = Permutation (1, 5, 4)(2, 3)
    </input>

    <\unfolded-io|Python] >
      a * b
    <|unfolded-io>
      \ Permutation([0, 4, 2, 5, 1, 3])
    </unfolded-io>

    <\unfolded-io|Python] >
      ( a * b ).full_cyclic_form
    <|unfolded-io>
      \ [[0], [1, 4], [2], [3, 5]]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      a = Permutation (1, 4, 6, 3, 7)(2, 8)
    </input>

    <\input|Python] >
      b = Permutation (2, 5, 3)(4, 7, 8, 1)
    </input>

    <\unfolded-io|Python] >
      a * b
    <|unfolded-io>
      \ Permutation([0, 7, 1, 8, 6, 3, 2, 4, 5])
    </unfolded-io>

    <\unfolded-io|Python] >
      ( a * b ).full_cyclic_form
    <|unfolded-io>
      \ [[0], [1, 7, 4, 6, 2], [3, 8, 5]]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      a = Permutation (1, 3, 2)
    </input>

    <\input|Python] >
      b = Permutation (4, 5)
    </input>

    <\unfolded-io|Python] >
      ( a * b ).full_cyclic_form
    <|unfolded-io>
      \ [[0], [1, 3, 2], [4, 5]]
    </unfolded-io>

    <\unfolded-io|Python] >
      ( b * a ).full_cyclic_form
    <|unfolded-io>
      \ [[0], [1, 3, 2], [4, 5]]
    </unfolded-io>

    <\unfolded-io|Python] >
      ( a * b ).array_form
    <|unfolded-io>
      \ [0, 3, 1, 2, 5, 4]
    </unfolded-io>

    <\unfolded-io|Python] >
      a**2
    <|unfolded-io>
      \ Permutation([0, 2, 3, 1])
    </unfolded-io>

    <\unfolded-io|Python] >
      a**3
    <|unfolded-io>
      \ Permutation([0, 1, 2, 3])
    </unfolded-io>

    <\unfolded-io|Python] >
      a.order()
    <|unfolded-io>
      \ 3
    </unfolded-io>

    <\unfolded-io|Python] >
      ( a * b ).order()
    <|unfolded-io>
      \ 6
    </unfolded-io>

    <\unfolded-io|Python] >
      a**(-1)
    <|unfolded-io>
      \ Permutation([0, 2, 3, 1])
    </unfolded-io>

    <\unfolded-io|Python] >
      a
    <|unfolded-io>
      \ Permutation([0, 3, 1, 2])
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\unfolded-io|Python] >
      len(list(symmetric(5)))
    <|unfolded-io>
      \ 120
    </unfolded-io>

    <\unfolded-io|Python] >
      factorial(5)
    <|unfolded-io>
      \ 120
    </unfolded-io>

    <\input|Python] >
      S5 = list(symmetric(5))
    </input>

    <\input|Python] >
      # \ a = S5["(2,3),(1,4)"] \ ## in Sage
    </input>

    <\input|Python] >
      D5 = dict([(i, S5[i].cyclic_form) for i in range(len(S5))])
    </input>

    <\unfolded-io|Python] >
      D5.get(80)
    <|unfolded-io>
      \ [[0, 3]]
    </unfolded-io>

    <\unfolded-io|Python] >
      for i in range(len(S5)):

      \ \ \ \ print i, ' \ ', D5.get(i)
    <|unfolded-io>
      0 \ \ \ []

      1 \ \ \ [[3, 4]]

      2 \ \ \ [[2, 3]]

      3 \ \ \ [[2, 3, 4]]

      4 \ \ \ [[2, 4, 3]]

      5 \ \ \ [[2, 4]]

      6 \ \ \ [[1, 2]]

      7 \ \ \ [[1, 2], [3, 4]]

      8 \ \ \ [[1, 2, 3]]

      9 \ \ \ [[1, 2, 3, 4]]

      10 \ \ \ [[1, 2, 4, 3]]

      11 \ \ \ [[1, 2, 4]]

      12 \ \ \ [[1, 3, 2]]

      13 \ \ \ [[1, 3, 4, 2]]

      14 \ \ \ [[1, 3]]

      15 \ \ \ [[1, 3, 4]]

      16 \ \ \ [[1, 3], [2, 4]]

      17 \ \ \ [[1, 3, 2, 4]]

      18 \ \ \ [[1, 4, 3, 2]]

      19 \ \ \ [[1, 4, 2]]

      20 \ \ \ [[1, 4, 3]]

      21 \ \ \ [[1, 4]]

      22 \ \ \ [[1, 4, 2, 3]]

      23 \ \ \ [[1, 4], [2, 3]]

      24 \ \ \ [[0, 1]]

      25 \ \ \ [[0, 1], [3, 4]]

      26 \ \ \ [[0, 1], [2, 3]]

      27 \ \ \ [[0, 1], [2, 3, 4]]

      28 \ \ \ [[0, 1], [2, 4, 3]]

      29 \ \ \ [[0, 1], [2, 4]]

      30 \ \ \ [[0, 1, 2]]

      31 \ \ \ [[0, 1, 2], [3, 4]]

      32 \ \ \ [[0, 1, 2, 3]]

      33 \ \ \ [[0, 1, 2, 3, 4]]

      34 \ \ \ [[0, 1, 2, 4, 3]]

      35 \ \ \ [[0, 1, 2, 4]]

      36 \ \ \ [[0, 1, 3, 2]]

      37 \ \ \ [[0, 1, 3, 4, 2]]

      38 \ \ \ [[0, 1, 3]]

      39 \ \ \ [[0, 1, 3, 4]]

      40 \ \ \ [[0, 1, 3], [2, 4]]

      41 \ \ \ [[0, 1, 3, 2, 4]]

      42 \ \ \ [[0, 1, 4, 3, 2]]

      43 \ \ \ [[0, 1, 4, 2]]

      44 \ \ \ [[0, 1, 4, 3]]

      45 \ \ \ [[0, 1, 4]]

      46 \ \ \ [[0, 1, 4, 2, 3]]

      47 \ \ \ [[0, 1, 4], [2, 3]]

      48 \ \ \ [[0, 2, 1]]

      49 \ \ \ [[0, 2, 1], [3, 4]]

      50 \ \ \ [[0, 2, 3, 1]]

      51 \ \ \ [[0, 2, 3, 4, 1]]

      52 \ \ \ [[0, 2, 4, 3, 1]]

      53 \ \ \ [[0, 2, 4, 1]]

      54 \ \ \ [[0, 2]]

      55 \ \ \ [[0, 2], [3, 4]]

      56 \ \ \ [[0, 2, 3]]

      57 \ \ \ [[0, 2, 3, 4]]

      58 \ \ \ [[0, 2, 4, 3]]

      59 \ \ \ [[0, 2, 4]]

      60 \ \ \ [[0, 2], [1, 3]]

      61 \ \ \ [[0, 2], [1, 3, 4]]

      62 \ \ \ [[0, 2, 1, 3]]

      63 \ \ \ [[0, 2, 1, 3, 4]]

      64 \ \ \ [[0, 2, 4, 1, 3]]

      65 \ \ \ [[0, 2, 4], [1, 3]]

      66 \ \ \ [[0, 2], [1, 4, 3]]

      67 \ \ \ [[0, 2], [1, 4]]

      68 \ \ \ [[0, 2, 1, 4, 3]]

      69 \ \ \ [[0, 2, 1, 4]]

      70 \ \ \ [[0, 2, 3], [1, 4]]

      71 \ \ \ [[0, 2, 3, 1, 4]]

      72 \ \ \ [[0, 3, 2, 1]]

      73 \ \ \ [[0, 3, 4, 2, 1]]

      74 \ \ \ [[0, 3, 1]]

      75 \ \ \ [[0, 3, 4, 1]]

      76 \ \ \ [[0, 3, 1], [2, 4]]

      77 \ \ \ [[0, 3, 2, 4, 1]]

      78 \ \ \ [[0, 3, 2]]

      79 \ \ \ [[0, 3, 4, 2]]

      80 \ \ \ [[0, 3]]

      81 \ \ \ [[0, 3, 4]]

      82 \ \ \ [[0, 3], [2, 4]]

      83 \ \ \ [[0, 3, 2, 4]]

      84 \ \ \ [[0, 3, 1, 2]]

      85 \ \ \ [[0, 3, 4, 1, 2]]

      86 \ \ \ [[0, 3], [1, 2]]

      87 \ \ \ [[0, 3, 4], [1, 2]]

      88 \ \ \ [[0, 3], [1, 2, 4]]

      89 \ \ \ [[0, 3, 1, 2, 4]]

      90 \ \ \ [[0, 3, 1, 4, 2]]

      91 \ \ \ [[0, 3, 2], [1, 4]]

      92 \ \ \ [[0, 3], [1, 4, 2]]

      93 \ \ \ [[0, 3, 2, 1, 4]]

      94 \ \ \ [[0, 3], [1, 4]]

      95 \ \ \ [[0, 3, 1, 4]]

      96 \ \ \ [[0, 4, 3, 2, 1]]

      97 \ \ \ [[0, 4, 2, 1]]

      98 \ \ \ [[0, 4, 3, 1]]

      99 \ \ \ [[0, 4, 1]]

      100 \ \ \ [[0, 4, 2, 3, 1]]

      101 \ \ \ [[0, 4, 1], [2, 3]]

      102 \ \ \ [[0, 4, 3, 2]]

      103 \ \ \ [[0, 4, 2]]

      104 \ \ \ [[0, 4, 3]]

      105 \ \ \ [[0, 4]]

      106 \ \ \ [[0, 4, 2, 3]]

      107 \ \ \ [[0, 4], [2, 3]]

      108 \ \ \ [[0, 4, 3, 1, 2]]

      109 \ \ \ [[0, 4, 1, 2]]

      110 \ \ \ [[0, 4, 3], [1, 2]]

      111 \ \ \ [[0, 4], [1, 2]]

      112 \ \ \ [[0, 4, 1, 2, 3]]

      113 \ \ \ [[0, 4], [1, 2, 3]]

      114 \ \ \ [[0, 4, 2], [1, 3]]

      115 \ \ \ [[0, 4, 1, 3, 2]]

      116 \ \ \ [[0, 4, 2, 1, 3]]

      117 \ \ \ [[0, 4], [1, 3, 2]]

      118 \ \ \ [[0, 4, 1, 3]]

      119 \ \ \ [[0, 4], [1, 3]]
    </unfolded-io>

    <\unfolded-io|Python] >
      Permutation\ 
    <|unfolded-io>
      Traceback (most recent call last):

      \ \ File "tm_python", line 1

      \ \ \ \ Permutation a

      \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ ^

      SyntaxError: invalid syntax
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\unfolded-io|Python] >
      D5
    <|unfolded-io>
      \ {0: [], 1: [[3, 4]], 2: [[2, 3]], 3: [[2, 3, 4]], 4: [[2, 4, 3]], 5:
      [[2, 4]], 6: [[1, 2]], 7: [[1, 2], [3, 4]], 8: [[1, 2, 3]], 9: [[1, 2,
      3, 4]], 10: [[1, 2, 4, 3]], 11: [[1, 2, 4]], 12: [[1, 3, 2]], 13: [[1,
      3, 4, 2]], 14: [[1, 3]], 15: [[1, 3, 4]], 16: [[1, 3], [2, 4]], 17:
      [[1, 3, 2, 4]], 18: [[1, 4, 3, 2]], 19: [[1, 4, 2]], 20: [[1, 4, 3]],
      21: [[1, 4]], 22: [[1, 4, 2, 3]], 23: [[1, 4], [2, 3]], 24: [[0, 1]],
      25: [[0, 1], [3, 4]], 26: [[0, 1], [2, 3]], 27: [[0, 1], [2, 3, 4]],
      28: [[0, 1], [2, 4, 3]], 29: [[0, 1], [2, 4]], 30: [[0, 1, 2]], 31:
      [[0, 1, 2], [3, 4]], 32: [[0, 1, 2, 3]], 33: [[0, 1, 2, 3, 4]], 34:
      [[0, 1, 2, 4, 3]], 35: [[0, 1, 2, 4]], 36: [[0, 1, 3, 2]], 37: [[0, 1,
      3, 4, 2]], 38: [[0, 1, 3]], 39: [[0, 1, 3, 4]], 40: [[0, 1, 3], [2,
      4]], 41: [[0, 1, 3, 2, 4]], 42: [[0, 1, 4, 3, 2]], 43: [[0, 1, 4, 2]],
      44: [[0, 1, 4, 3]], 45: [[0, 1, 4]], 46: [[0, 1, 4, 2, 3]], 47: [[0, 1,
      4], [2, 3]], 48: [[0, 2, 1]], 49: [[0, 2, 1], [3, 4]], 50: [[0, 2, 3,
      1]], 51: [[0, 2, 3, 4, 1]], 52: [[0, 2, 4, 3, 1]], 53: [[0, 2, 4, 1]],
      54: [[0, 2]], 55: [[0, 2], [3, 4]], 56: [[0, 2, 3]], 57: [[0, 2, 3,
      4]], 58: [[0, 2, 4, 3]], 59: [[0, 2, 4]], 60: [[0, 2], [1, 3]], 61:
      [[0, 2], [1, 3, 4]], 62: [[0, 2, 1, 3]], 63: [[0, 2, 1, 3, 4]], 64:
      [[0, 2, 4, 1, 3]], 65: [[0, 2, 4], [1, 3]], 66: [[0, 2], [1, 4, 3]],
      67: [[0, 2], [1, 4]], 68: [[0, 2, 1, 4, 3]], 69: [[0, 2, 1, 4]], 70:
      [[0, 2, 3], [1, 4]], 71: [[0, 2, 3, 1, 4]], 72: [[0, 3, 2, 1]], 73:
      [[0, 3, 4, 2, 1]], 74: [[0, 3, 1]], 75: [[0, 3, 4, 1]], 76: [[0, 3, 1],
      [2, 4]], 77: [[0, 3, 2, 4, 1]], 78: [[0, 3, 2]], 79: [[0, 3, 4, 2]],
      80: [[0, 3]], 81: [[0, 3, 4]], 82: [[0, 3], [2, 4]], 83: [[0, 3, 2,
      4]], 84: [[0, 3, 1, 2]], 85: [[0, 3, 4, 1, 2]], 86: [[0, 3], [1, 2]],
      87: [[0, 3, 4], [1, 2]], 88: [[0, 3], [1, 2, 4]], 89: [[0, 3, 1, 2,
      4]], 90: [[0, 3, 1, 4, 2]], 91: [[0, 3, 2], [1, 4]], 92: [[0, 3], [1,
      4, 2]], 93: [[0, 3, 2, 1, 4]], 94: [[0, 3], [1, 4]], 95: [[0, 3, 1,
      4]], 96: [[0, 4, 3, 2, 1]], 97: [[0, 4, 2, 1]], 98: [[0, 4, 3, 1]], 99:
      [[0, 4, 1]], 100: [[0, 4, 2, 3, 1]], 101: [[0, 4, 1], [2, 3]], 102:
      [[0, 4, 3, 2]], 103: [[0, 4, 2]], 104: [[0, 4, 3]], 105: [[0, 4]], 106:
      [[0, 4, 2, 3]], 107: [[0, 4], [2, 3]], 108: [[0, 4, 3, 1, 2]], 109:
      [[0, 4, 1, 2]], 110: [[0, 4, 3], [1, 2]], 111: [[0, 4], [1, 2]], 112:
      [[0, 4, 1, 2, 3]], 113: [[0, 4], [1, 2, 3]], 114: [[0, 4, 2], [1, 3]],
      115: [[0, 4, 1, 3, 2]], 116: [[0, 4, 2, 1, 3]], 117: [[0, 4], [1, 3,
      2]], 118: [[0, 4, 1, 3]], 119: [[0, 4], [1, 3]]}
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    \;
  </session>
</body>

<initial|<\collection>
</collection>>