<TeXmacs|1.0.7.19>

<style|generic>

<\body>
  <\session|python|default>
    <\output>
      Python plugin for TeXmacs.

      Please see the documentation in Help -\<gtr\> plugins -\<gtr\> Python
    </output>

    <\input|Python] >
      from sympy import *
    </input>

    <\unfolded-io|Python] >
      var('a:z')
    <|unfolded-io>
      \ (a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u, v, w,
      x, y, z)
    </unfolded-io>

    <\input|Python] >
      from sympy.combinatorics.permutations import *
    </input>

    <\input|Python] >
      import itertools
    </input>

    <\input|Python] >
      from sympy.combinatorics.generators import symmetric
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      <\code>
        from __future__ import print_function, division

        \;

        import random

        from collections import defaultdict

        from sympy.core import Basic

        from sympy.core.compatibility import is_sequence, reduce, xrange

        from sympy.utilities.iterables import (flatten, has_variety, minlex,

        has_dups, runs)

        from sympy.polys.polytools import lcm

        from sympy.matrices import zeros

        from sympy.mpmath.libmp.libintmath import ifac
      </code>
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      p = Permutation (1, 10, 8, 12)(4, 14)(6, 15, 16)(7, 11, 13, 9)
    </input>

    <\unfolded-io|Python] >
      p.transpositions()
    <|unfolded-io>
      \ [(1, 12), (1, 8), (1, 10), (4, 14), (6, 16), (6, 15), (7, 9), (7,
      13), (7, 11)]
    </unfolded-io>

    <\input|Python] >
      p = Permutation (1, 3, 5, 2)(4, 7)
    </input>

    <\unfolded-io|Python] >
      p.transpositions()
    <|unfolded-io>
      \ [(1, 2), (1, 5), (1, 3), (4, 7)]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      R = Permutation (1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16,
      17, 18, 19, 20)
    </input>

    <\input|Python] >
      T = Permutation (1, 4)(2, 3)
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      result = R * T * R**(-1)
    </input>

    <\unfolded-io|Python] >
      result
    <|unfolded-io>
      \ Permutation(1, 2)(3, 20)
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      result = R**(-4) * T * R**2 * T * R**(-1)
    </input>

    <\unfolded-io|Python] >
      result
    <|unfolded-io>
      \ Permutation(1, 18, 15, 12, 9, 6, 4, 2, 19, 16, 13, 10, 7, 20, 17, 14,
      11, 8)
    </unfolded-io>

    <\unfolded-io|Python] >
      result.transpositions()
    <|unfolded-io>
      \ [(1, 8), (1, 11), (1, 14), (1, 17), (1, 20), (1, 7), (1, 10), (1,
      13), (1, 16), (1, 19), (1, 2), (1, 4), (1, 6), (1, 9), (1, 12), (1,
      15), (1, 18)]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      L = Permutation (1, 20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8,
      7, 6, 5, 4, 3, 2)
    </input>

    <\input|Python] >
      R = Permutation (1, 38, 37, 36, 35, 6, 34, 33, 32, 31, 30, 29, 28, 27,
      26, 25, 24, 23, 22, 21)
    </input>

    <\unfolded-io|Python] >
      R**(-1) * L * R
    <|unfolded-io>
      \ Permutation(2, 38, 20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8,
      7, 34, 5, 4, 3)
    </unfolded-io>

    <\unfolded-io|Python] >
      L**5 * R**5 * L**(-5) * R**(-5)
    <|unfolded-io>
      \ Permutation(38)(1, 25)(6, 11)
    </unfolded-io>

    <\unfolded-io|Python] >
      (L**5 * R**5 * L**(-5) * R**(-5)).transpositions()
    <|unfolded-io>
      \ [(1, 25), (6, 11)]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      R = Permutation (25, 27, 32, 30)(26, 29, 31, 28)(3, 38, 43, 19)(5, 36,
      45, 21)(8, 33, 48, 24)
    </input>

    <\input|Python] >
      L = Permutation (9, 11, 16, 14)(10, 13, 15, 12)(1, 17, 41, 40)(4, 20,
      44, 37)(6, 22, 46, 35)
    </input>

    <\input|Python] >
      U = Permutation (1, 3, 8, 6)(2, 5, 7, 4)(9, 33, 25, 17)(10, 34, 26,
      18)(11, 35, 27, 19)
    </input>

    <\input|Python] >
      D = Permutation (41, 43, 48, 46)(42, 45, 47, 44)(14, 22, 30, 38)(15,
      23, 31, 39)(16, 24, 32, 40)
    </input>

    <\input|Python] >
      F = Permutation (17, 19, 24, 22)(18, 21, 23, 20)(6, 25, 43, 16)(7, 28,
      42, 13)(8, 30, 41, 11)
    </input>

    <\input|Python] >
      B = Permutation (33, 35, 40, 38)(34, 37, 39, 36)(3, 9, 46, 32)(2, 12,
      47, 29)(1, 14, 48, 27)
    </input>

    <\input|Python] >
      \;
    </input>

    <\unfolded-io|Python] >
      R * U
    <|unfolded-io>
      \ Permutation(1, 3, 38, 43, 11, 35, 27, 32, 30, 17, 9, 33, 48, 24,
      6)(2, 5, 36, 45, 21, 7, 4)(8, 25, 19)(10, 34, 26, 29, 31, 28, 18)
    </unfolded-io>

    <\unfolded-io|Python] >
      (R * U)**15
    <|unfolded-io>
      \ Permutation(48)(2, 5, 36, 45, 21, 7, 4)(10, 34, 26, 29, 31, 28, 18)
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    <\input|Python] >
      q = Permutation (1, 2, 3, 4, 5)
    </input>

    <\unfolded-io|Python] >
      q.transpositions()
    <|unfolded-io>
      \ [(1, 5), (1, 4), (1, 3), (1, 2)]
    </unfolded-io>

    <\input|Python] >
      \;
    </input>

    \;
  </session>
</body>

<initial|<\collection>
</collection>>